-- TODO: Update payee name. 
select strftime('%Y', TRANSDATE) as YEAR
    , '' as COLOR 
    , total(case when '01' = strftime('%m', TRANSDATE) then TRANSAMOUNT * BASECONVRATE else null end) as Jan
    , total(case when '02' = strftime('%m', TRANSDATE) then TRANSAMOUNT * BASECONVRATE else null end) as Feb
    , total(case when '03' = strftime('%m', TRANSDATE) then TRANSAMOUNT * BASECONVRATE else null end) as Mar
    , total(case when '04' = strftime('%m', TRANSDATE) then TRANSAMOUNT * BASECONVRATE else null end) as Apr
    , total(case when '05' = strftime('%m', TRANSDATE) then TRANSAMOUNT * BASECONVRATE else null end) as May
    , total(case when '06' = strftime('%m', TRANSDATE) then TRANSAMOUNT * BASECONVRATE else null end) as Jun
    , total(case when '07' = strftime('%m', TRANSDATE) then TRANSAMOUNT * BASECONVRATE else null end) as Jul
    , total(case when '08' = strftime('%m', TRANSDATE) then TRANSAMOUNT * BASECONVRATE else null end) as Aug
    , total(case when '09' = strftime('%m', TRANSDATE) then TRANSAMOUNT * BASECONVRATE else null end) as Sep
    , total(case when '10' = strftime('%m', TRANSDATE) then TRANSAMOUNT * BASECONVRATE else null end) as Oct
    , total(case when '11' = strftime('%m', TRANSDATE) then TRANSAMOUNT * BASECONVRATE else null end) as Nov
    , total(case when '12' = strftime('%m', TRANSDATE) then TRANSAMOUNT * BASECONVRATE else null end) as Dec
from CHECKINGACCOUNT_V1 
inner join ACCOUNTLIST_V1 on ACCOUNTLIST_V1.ACCOUNTID = CHECKINGACCOUNT_V1.ACCOUNTID
inner join CURRENCYFORMATS_V1 on CURRENCYFORMATS_V1.CURRENCYID = ACCOUNTLIST_V1.CURRENCYID
inner join  PAYEE_V1
on CHECKINGACCOUNT_V1.PAYEEID = PAYEE_V1.PAYEEID
where PAYEENAME = 'Payee1'
    and CHECKINGACCOUNT_V1.TRANSCODE='Withdrawal'
    and CHECKINGACCOUNT_V1.STATUS <> 'V'
group by year
order by year desc;
